section
  name General Overview

  figure
    name General Overview
    artwork(align='center' type='binary-art' src='motion-control-software-architecture/general_overview.png')

  section(anchor="s-fmc_carrier")
    name Spexi7u carrier

    t
      | The Spexi7u carrier board is based on a Xilinx UltraScale+ FPGA which
      | hosts a #[xref(target='s-logical_unit') Logical Unit] implementing
      | time-critical modules, two ARM Cortex-A53
      | "Application Processing Units" and two ARM Cortex-R5
      | "Real-Time Processing Units".

    t
      | Motion-Control in SAMbuCa uses one of the "Application Processing Units",
      | #[xref(target='s-apu0') APU0].

    t
      | some more detailed information can be found #[eref(target='http://cs-ccr-www3/private/coht/sphinx/spexi7/spexi7u-base.html#') here].

    figure
      name Xilinx UltraScale+CG block representation (source: Xilinx.com)
      artwork(align='center' type='binary-art' src='motion-control-software-architecture/zynq-cg-block.PNG')

    section(anchor='s-logical_unit')
      name Logical Unit

      t
        | A specific "MFE" (Motion Front-End) gateware is loaded in the
        | logical unit, it provides some IO logic through the "Motion Core"
        | and "GRBL Digitial IO" modules as well as communication channel
        | through the "GRBL FIFO".

      t
        | Modules documentation can be found #[eref(target="http://cs-ccr-www3/private/coht/sphinx/fmc-mfe/gateware.html") here].

    section(anchor='s-apu0')
      name Application Processing Unit

      t
        | The first "Application Processing Unit" (APU0), is used to run
        | #[xref(target='s-grbl') Grbl] engine.